#include "Average.h"

int weights[] = { -2, 3, 6, 7, 6, 3, -2 };

Average::Average() {
  this->lowPtr = this->highPtr = 0;
  this->caliber = 0;
}

void Average::calibrate(int cal) {
  this->caliber = cal;
}

void Average::sample(int val) {
  samples[this->highPtr] = val;
  this->highPtr = (this->highPtr + 1) % SAMPLES;
  if (this->highPtr == this->lowPtr) this->lowPtr = (this->lowPtr + 1) % SAMPLES;
}

int Average::average() {
  long total = 0;
  for (int i = 0; i < SAMPLES; i++) {
    total += this->samples[(i+this->highPtr)%SAMPLES] * weights[i];
  }
  total /= 21;
  return total - caliber;
}

